/* YOODA : Yet another Object Oriented Database
   Copyright (C) 1994  Eric Abecassis

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Library General Public
License as published by the Free Software Foundation; either
version 2 of the License, or (at your option) any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Library General Public License for more details.

You should have received a copy of the GNU Library General Public
License along with this library; if not, write to the Free
Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA. */

#pragma interface

#include "sockrpc.hxx"
#include "list.hxx"

class InfoClient {
  private :
  
  char* _name ;
  int   _pid ;
  ListVal<char*> _servers ;

  public :
  
  InfoClient() {} ;
  InfoClient(int p, char* n, char* s) : _name(strdup(n)), _pid(p) {
    _servers += s ;
  }  
  char* name() { return _name ; }
  int pid() { return _pid ; }
  ListVal<char*>& servers() { return _servers ; }
  void addServer(char* server) { this->_servers += server ; }

  friend SvcSocket& operator<<(SvcSocket& svc, InfoClient& tr) ;
  friend SvcSocket& operator>>(SvcSocket& svc, InfoClient& tr) ;
} ;


void display_bases(ListVal<char*>& l_bases) ;
ListVal<char*>& list_bases() ;
ListVal<char*>& list_servers(char* base) ;
void display_servers(char* base, ListVal<char*>& l_servers) ;
void kill_server(char* base, char* server) ;
ListVal<InfoClient>& list_clients(char* base) ;
void display_clients(ListVal<InfoClient>& list_in) ;
void kill_client(char* base, int pid) ;
void kill_all_servers(char* base) ;
